//----------------------------------------------------------
#ifndef FrmTextrH
#define FrmTextrH
//----------------------------------------------------------
#include <d3drmwin.h>
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Dialogs.hpp>
//----------------------------------------------------------
class TTextureForm : public TForm {
__published:  // IDE-managed Components
  TBevel *Bevel1;
  TLabel *laColors;
  TEdit *edColors;
  TLabel *laShades;
  TEdit *edShades;
  TLabel *laDecalScale;
  TGroupBox *gbOrigin;
  TLabel *laOriginX;
  TEdit *edOriginX;
  TLabel *laOriginY;
  TEdit *edOriginY;
  TGroupBox *gbSize;
  TLabel *laWidth;
  TEdit *edWidth;
  TLabel *laHeight;
  TEdit *edHeight;
  TCheckBox *cbTransparent;
  TGroupBox *gbTransparentColor;
  TTrackBar *tbRed;
  TTrackBar *tbGreen;
  TTrackBar *tbBlue;
  TLabel *laRed;
  TLabel *laGreen;
  TLabel *laBlue;
  TShape *Shape;
  TLabel *laR;
  TLabel *laG;
  TLabel *laB;
  TCheckBox *cbScaled;
  TButton *btnRemove;
  TButton *btnOpen;
  TLabel *laTexPath;
  TButton *btnReload;
  TOpenDialog *OpenDlg;
  TColorDialog *ColorDlg;
  void __fastcall TextureChanged(TObject *Sender);
  void __fastcall EditorsKeyPress(TObject *Sender, char &Key);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
  TShiftState Shift);
  void __fastcall btnRemoveClick(TObject *Sender);
  void __fastcall btnOpenClick(TObject *Sender);
  void __fastcall btnReloadClick(TObject *Sender);
  void __fastcall ShapeMouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y);
private:    // User declarations
  void* FObject;
  LPDIRECT3DRMTEXTURE IRMTexture;
  LONG OriginX, OriginY;
  DWORD Colors, Shades, DecalScale;
  D3DVALUE DecalWidth, DecalHeight;
  BOOL Transparency;
  D3DCOLOR TransColor;
  bool IsReading;
  void __fastcall EnableControls(bool enable);
  void __fastcall AssignTexture(LPDIRECT3DRMTEXTURE ITex);
public:     // User declarations
  __fastcall TTextureForm(TComponent* Owner);
  __fastcall ~TTextureForm();
  void __fastcall SetNone();
  void __fastcall Manage(void* object);
  void __fastcall GetTextureData();
};
//----------------------------------------------------------
extern TTextureForm *TextureForm;
//----------------------------------------------------------
#endif
